from typing import List, Dict, Tuple, Optional
import re
from objects import REG, DFA, Terminal

# TODO ask: commas at the ends of lines or not?
class Parser:
    def __init__(self):
        pass

    def reg_to_str(self, reg: REG, full=False) -> str:
        rules = self.rules_to_str(reg.rules)
        if not full:
            return "P=" + rules

        out = "(("
        for nonterminal in reg.nonterminals:
            out += (nonterminal.name)
            out += (",")

        out = out[:-1] + ("),(")
        for terminal in reg.terminals:
            out += (terminal.name)
            out += (",")

        out = out[:-1] + ("),P," + reg.init.name + ")\nP=")
        out += (self.rules_to_str(reg.rules))
        return out


    # TODO ask: from objects import rules (as type)?
    def rules_to_str(self, rules):
        out = ""
        for rule in rules:
            out = out[:-1] + (",\n")
            rewrite = rules[rule]
            if len(rewrite) == 0:
                continue

            out += (rule.name + "->")
            for variant in rewrite:
                if type(variant) == Terminal:
                    out += variant.name
                else:
                    for i in range(len(variant)):
                        out += (variant[i].name)
                if next:  # TODO
                    out += ("|")

        return ("{" + out[2:len(out) - 1] + "}")


    #    def str_to_reg(self, source: str) -> REG:
    #        re.match(...((nt),(t),P,S)\n rest

    def dfa_to_str(self, dfa: DFA, full=False) -> str:

        # full - verbose description of DFA - only for development, dismiss later
        
        states = "{"
        for state in dfa.states:
                states += state.name + ","
        states = states[:-1] + "}"

        # Vlada: states = ",".join(dfa.states) but I use it wrong or what
            
        terminals = "{"
        for terminal in dfa.terminals:
                terminals += terminal.name + ","
        terminals = terminals[:-1] + "}"

        transition = ""
        for key, state_2 in dfa.transition.items():
            state_1, terminal = key
            transition += "(" + state_1.name + "," + terminal.name + ")=" + state_2.name + "\n"
        transition = "{" + transition[:-1] + "}"

        init = dfa.init.name

        final = "F={"
        for state in dfa.final:
            final += state.name + ","
        final = final[:-1] + "}"

        if full:
            return "DFA = (" + states + "," + terminals + ",d," + \
                  init + "," + final + ")\n" + "d = " + transition

        else:
            return transition + "\n" + final

# all: string <-> formal object
# reg
# dfa
# nfa
# pda
# cfg